ASTRING - Editorial

PROBLEM LINK

Practice

Contest

Contributors

Author: Amit Pandey

Tester & Editorialist: Prateek Gupta

DIFFICULTY:

Easy

PREREQUISITES:

Sets, Implementation

PROBLEM:

Find the smallest lexicographical subsequence of length K from a given string of length N

EXPLANATION

Solution for Subtask 1:

The smallest subtask can indeed be solved by dynamic programming. Basically, you have a choice at every position of the string S i.e, whether to include a character at particular position in final subsequence of K characters or not. Now, let’s define a DP state as dp(i,\ j) denoting the smallest lexicographical subsequence of length j formed from first i characters of the original string S. Hence, the following equations hold true.

dp(0,\ 0)\ =\ null
dp(0,\ j)\ =\ INF\quad \forall\quad j\ \in\ (1,\ N)
dp(i,\ j)\ =\ min(\ dp(i\ -\ 1,\ j)\ ,\ s_i + dp(i\ -\ 1,\ j\ -\ 1)

Let’s have a look at the pseudo code for the bottom up solution of the above approach.

    dp[0][0] = ""
	for ( j = 1 to K ) dp[0][j] = "INF"
	
	for ( i = 1 to N )  {
		for ( j = 1 to K  ) { 
			dp[i][j] = "INF"
			if ( dp[i - 1][j] != "INF" ) dp[i][j] = dp[i - 1][j]
			if ( dp[i - 1][j - 1] != "INF" )  {
				if ( dp[i][j] == "INF" ) dp[i][j] = dp[i - 1][j - 1] + s[i - 1]
				else dp[i][j] = min(dp[i][j], dp[i - 1][j - 1] + s[i - 1])
            }
        }
    }
				
	print(dp[N][K])

The same thing can be implemented by recursive memoization solution. You might like to read this blog post to know more about Dynamic Programming. The time complexity for the above approach is \mathcal{O}(N^{2}) but the space complexity is around \mathcal{O}(N^{3}). Due to the higher space complexity, it won’t be possible to implement the same solution for subtask 2 as it can cause memory overflow leading to Runtime Error.

Solution for subtask 2:

The approach for this subtask is based on the fact that the subsequence formed at last has to be of length K exactly. Having said that, it is not difficult to realize that the first character of the smallest lexicographical subsequence has to be from substring s[0,\ n\ -\ k]. Why? If the first character is not from this substring, then it would not be possible to form a subsequence of length K. Similarly, the i^{th} character should be from the substring s[prev\ +\ 1,\ n\ -\ k\ +\ i], where prev is the position found for (i - 1)^{th} character of the subsequence. Hence, we should always choose the smallest characters in the substrings. And in case, there are two smallest characters, we should choose the one with leftmost position, since it will give a larger substring to choose from, for the rest of the characters in the subsequence. Let us look at the pseudo code for this greedy approach.

    subseq = ""
	prev_pos = -1
	for ( i from 0 to k - 1 ) {
		for ( j from last_pos + 1 to n - k + i ) {
			if ( j == last_pos + 1 ) smallest_char = s[j], leftmost_pos = j
			else if ( smallest_char > s[j] ) smallest_char = s[j], leftmost_pos = j
        }
		prev_pos = leftmost_pos
		subseq.append(smallest_char)
	}

    print(subseq)

Since, for all K characters of the subsequence, it traverses the whole string in the worst case to find the smallest character, the time complexity for this pseudo code is \mathcal{O}(N*K). But, this does not yet suffice to pass all the input files.

Solution for subtask 3:

The logical approach for the problem remains the same as mentioned in the subtask 2. But, the implementation can be optimized to reduce the overall time complexity. For this, we can maintain a data structure that will give the smallest character in a range and in case, there are several smaller characters, it can give us the position of the leftmost smallest character in that range. The data structure which seems most easier ti implement at this stage is a set of pairs. Hence, the pairs of (characters, indexes) will be inserted into the set when required and removed when they go outside the current range. The first element of the set will give us the required character and it’s corresponding index for that particular position. Let’s denote pos[x] as the index where the x^{th} character of the K-length subsequence was found.

To calculate the pos[i], the range that to be considered will be (pos[i\ -\ 1]\ +\ 1,\ n\ -\ k\ +\ i). Hence, the pairs within the range (pos[i\ -\ 2]\ +\ 1,\ pos[i\ -\ 1]) are removed and a new pair of (s_{n\ -\ k\ +\ i},\ n\ -\ k\ +\ i) should be inserted into the set. This would allow you to remove and insert each pair exactly once. Let us now have a look at the pseudo code for the same.

    for ( i = 0 to n - k ) Set.insert(make_pair(s[i], i))

	subseq.append(Set.top().character)

	a = 0, b = Set.top().index
	for (i = n - k + 1 to n - 1 ) {
		while ( a <= b )  Set.erase(make_pair(s[a], a)), a++
		Set.insert(make_pair(s[i], i))
		b = Set.top().second
		subseq.append(Set.top().character)
	}

    print(subseq)

For more details on the implementation of any subtasks, have a look at the tester’s solution.

COMPLEXITY

The overall complexity necessary to pass all the input files should be \mathcal{O}(N*logN).

SOLUTIONS

Setter
Tester’s solution to Subtask 1
Tester’s solution to Subtask 2
Tester’s solution to Subtask 3

1 Like

We can also use a segment tree to find the position and smallest character in the string in the required range

Code in C++ : CodeChef: Practical coding for everyone

1 Like

I did it by greedy implementation with worst case complexity O(N*26).

Here is the link to my solution: CodeChef: Practical coding for everyone

I also first implemented using segment tree but got TLE. Then I finally got AC using sparse table with O(NlogN) space and O(1) per query.
Click here to see the solution

Even the O(N*K) algorithm with pruning worked for all test cases.
Code in C : CodeChef: Practical coding for everyone

1 Like

Can anyone explain what’s wrong with my code or any tricky test case?
my code

We can do it by using stack overall complexity O(n).My Solution link : CodeChef: Practical coding for everyone

2 Likes

“[…] The time complexity for the
above approach is O(N^2) but the space
complexity is around O(N^3). […]”

I do not understand this statement, how can the space complexity ever be bigger than the time complexity, how would you generate O(n) memory in O(1) time ?

https://www.codechef.com/viewsolution/10206440

Here is what I did. Just searched for the best possible element of the substring from left to right.

3 Likes

I too solved it using segment trees. First idea that came to my mind was using RMQ. Here’s my solution CodeChef: Practical coding for everyone

int main()
{char a[100005],b[100005];
int t,i,m;
scanf("%d",&t);
for(m=0;m<t;m++)
{int k,len;
scanf("%s",a);
scanf("%d",&k);
len=strlen(a);
int p=len-k;
int j=0;
for(i=0;i<len;i++)
{
while(j!=0 && b[j-1]>a[i] && p!=0)
{
j–;
p–;
}
b[j]=a[i];
j++;
}
b[k]=’\0’;
printf("%s\n",b);

}
return 0;
}

I just sorted the string and took the substring from 0 to k. But it shows wrong answer. Can someone please highlight the mistake in my code.

int main()
{

int t;
cin>>t;
while(t--)
{
    string s;
    cin>>s;
    int k;
    cin>>k;
    sort(s.begin(),s.end());
    string s1=s.substr(0,k);
    cout<<s1<<endl;

}

}

Yes, but that would be too much for this problem. :stuck_out_tongue:

1 Like

https://www.codechef.com/viewsolution/10208562

my this soln passed… i thought of using segment tree had it failed…

Since, you are storing a string at each dp[i][j], basically you are storing another array of characters in a 2D array. Hence, the space complexity is O(N^3).

complexity?

It is actually O( K*(N-K+1) ) which is approximately O(N)

no its not O(N)

Consider case when : K = N / 2
It goes O(N * N)

Sorry, that’s a typo…I meant to say O(N^2)

Same here - CodeChef: Practical coding for everyone